# face rendering test app

# TODO:
# ability to cycle through all available facial features with # keys

import pygame
import math
import face
import vector
from colors import *
from sys import exit


FULLSCREEN = False
SCREEN_SIZE = SCREEN_WIDTH, SCREEN_HEIGHT = 800, 600
FRAMERATE = 30

# override scale to use full-res art
face.art_scale = 1.0

class TestFace():
    
    def __init__(self):
        self.style = feature_dir.random_style()
        self.loc = vector.Vector2D(SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2)
        self.loc += (vector.ORIGIN - feature_dir.heads[0].stages[0].image.get_size()) / 2
        self.aff = 0
    
    def draw(self):
        dir = vector.Vector2D(mouse_x, mouse_y) - self.loc
        dir = dir.normal()
        self.style.draw(screen, self.loc, dir, self.aff)
        # debug text
        y = 0
        lines = [
            "F1: reinitialize",
            "+/-: increase / decrease affinity",
            "-------------------------------",
            "Affinity: %s" % self.aff
        ]
        for line in lines:
            text_surf = debug_font.render(line, True, LIGHT_GREY)
            screen.blit(text_surf, (0, y))
            y += text_surf.get_height()


def input():
    global mouse_x, mouse_y
    mouse_x, mouse_y = pygame.mouse.get_pos()
    for event in pygame.event.get():
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_ESCAPE:
                exit()
            elif event.key in [pygame.K_EQUALS, pygame.K_PLUS]:
                tf.aff += 1
            elif event.key == pygame.K_MINUS:
                tf.aff -= 1
            elif event.key == pygame.K_F1:
                init()
        elif event.type == pygame.QUIT:
            exit()


def draw():
    screen.fill(BLACK)
    tf.draw()
    pygame.display.flip()


def main_loop():
    input()
    draw()
    clock.tick_busy_loop(FRAMERATE)


def init():
    global tf
    tf = TestFace()

if __name__ == "__main__":
    pygame.init()
    clock = pygame.time.Clock()
    if FULLSCREEN:
        screen = pygame.display.set_mode(SCREEN_SIZE, pygame.FULLSCREEN)
    else:
        screen = pygame.display.set_mode(SCREEN_SIZE)
    pygame.display.set_caption('POPULAR student face tester')
    pygame.key.set_repeat(50)
    df = pygame.font.get_default_font()
    debug_font = pygame.font.Font(df, 16)
    feature_dir = face.FaceFeatureDirectory()
    init()
    while True:
        main_loop()
