# module for "ranged dictionary"

class RangeDictionary():
    
    """
    Like a dict, but keys are a tuple range so key values are effectively
    quantizations.
    """
    
    def __init__(self, dict):
        self.keys = {}
        for item in dict:
            # only tuples can be keys for these
            if item.__class__ is not tuple:
                continue
            # if key range is (high, low) instead of (low, high), swap 'em
            if item[0] > item[1]:
                z = item[1]
                item[1] = item[0]
                item[0] = z
            self.keys[item] = dict[item]
    
    def __getitem__(self, i):
        for key in self.keys:
            if i >= key[0] and i <= key[1]:
                return self.keys[key]
        print "RangeDictionary: couldn't find a key for value %s" % i
        return None
